# coding: UTF-8

ROOT_PATH = File.dirname(File.expand_path(__FILE__)) + "/../../m2w"

$:.unshift(ROOT_PATH + "/")
$:.unshift(ROOT_PATH + "/../")
$:.unshift(ROOT_PATH + "/../../main/")
$:.unshift(ROOT_PATH + "/../../main/lib")

# mail2weblog ̃[gpXݒ肷
M2W_ROOT_PATH = ROOT_PATH + "/../../main/"

require 'm2w_configurator'

require 'minitest/unit'

MiniTest::Unit.autorun

#=metaWeblog API gW̃EFuOvOC̃eXg
#
# ŏ̒:: gDC[
# |Wg:: $Id: test_alteil_plugin.rb 271 2011-09-19 04:37:55Z toy_dev $
# 쌠:: Copyright (C) Ownway.info, 2011. All rights reserved.
# CZX:: CPL(Common Public Licence)
class TestMetaWeblog < MiniTest::Unit::TestCase

	def test_parse_date
		weblog = MetaWeblog_WeblogPlugin.new

		errors = []
		warnings = []
		result = weblog.parse_date(nil, nil, errors, warnings)
		assert_nil result
		assert_equal 0, errors.size
		assert_equal 0, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date('abcdef', nil, errors, warnings)
		assert_nil result
		assert_equal 0, errors.size
		assert_equal 1, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date('11/13', nil, errors, warnings)
		assert result != nil
		assert_equal 0, errors.size
		assert_equal 0, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date('11/13 13:30', nil, errors, warnings)
		assert result != nil
		assert_equal 0, errors.size
		assert_equal 0, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date('2011/11/13 13:30', nil, errors, warnings)
		assert result != nil
		assert_equal 0, errors.size
		assert_equal 0, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date('11/13 13:30:15', nil, errors, warnings)
		assert result != nil
		assert_equal 0, errors.size
		assert_equal 0, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date('2011/11/13 13:30:15', nil, errors, warnings)
		assert result != nil
		assert_equal 0, errors.size
		assert_equal 0, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date('2011/11/13 13:30:15+09:00', nil, errors, warnings)
		assert result != nil
		assert_equal 0, errors.size
		assert_equal 0, warnings.size

		errors = []
		warnings = []
		result = weblog.parse_date(nil, Time.now, errors, warnings)
		assert result != nil
		assert_equal 0, errors.size
		assert_equal 0, warnings.size
	end

end
