#!/usr/local/bin/ruby
# coding: UTF-8

#=メールを走査し、内容に応じてブログへの捜査を行う mail2weblog プログラム
#
# 最初の著者:: トゥイー
# リポジトリ情報:: $Id: m2w.rb 39 2011-06-01 13:51:30Z yutaka_at_home $
# 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
# ライセンス:: CPL(Common Public Licence)

# LOAD_PATH に lib フォルダを追加する
$:.unshift(File.dirname(__FILE__) + "/lib")
$:.unshift(File.dirname(__FILE__) + "/")

# Mail2Weblog のルートパスを設定する
M2W_ROOT_PATH = File.dirname(File.expand_path(__FILE__))

require 'm2w_configurator'
require 'mail_command_processor'
require 'weblog_command'

begin
  mail_command_processor = MailCommandProcessor.new(M2W_POP3_SERVER_ADDRESS, M2W_POP3_SERVER_PORT, M2W_POP3_SERVER_USER, M2W_POP3_SERVER_PASSWORD)
  mail_command_processor.add(WeblogCommand.new(M2W_WEBLOG_HOST, M2W_WEBLOG_ADDRESS, M2W_WEBLOG_USERNAME, M2W_WEBLOG_PASSWORD))

  mail_command_processor.run
rescue => e
  M2W_LOGGER.error(e)
end

puts "Content-type: text/plain\n\n"
puts "このプログラムは、cron などのスケジュール管理ソフトから呼び出すのが妥当です。"
