#!/usr/local/bin/ruby
# coding: UTF-8

#=メールを走査し、内容に応じてブログへの捜査を行う mail2weblog プログラム
#
# 最初の著者:: トゥイー
# リポジトリ情報:: $Id: m2w.rb 98 2011-06-26 02:02:24Z toy_dev $
# 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
# ライセンス:: CPL(Common Public Licence)

# mail2weblog のルートパスを設定する
M2W_ROOT_PATH = File.dirname(File.expand_path(__FILE__))

# LOAD_PATH に必要なフォルダを追加する
$:.unshift(M2W_ROOT_PATH + "/")
$:.unshift(M2W_ROOT_PATH + "/lib")

require 'm2w_configurator'
require 'm2w_mail_parser'
require 'm2w_mail_sender'
require 'weblog_command'
require 'mui/mail_command_processor'

begin
	mail_parser = Mail2WeblogMailParser.new(M2W_POST_COMMAND_HEADER_ALIAS)
	mail_sender = Mail2WeblogMailSender.new(M2W_SMTP_SERVER_ADDRESS, M2W_SMTP_SERVER_PORT, M2W_SMTP_SECURITY_TYPE, M2W_SMTP_SERVER_USER, M2W_SMTP_SERVER_PASSWORD, M2W_POP3_BEFORE_SMTP_SERVER_ADDRESS, M2W_POP3_BEFORE_SMTP_SERVER_PORT, M2W_POP3_BEFORE_SMTP_SERVER_USER, M2W_POP3_BEFORE_SMTP_SERVER_PASSWORD)
	mail_command_processor = MailCommandProcessor.new(M2W_POP3_SERVER_ADDRESS, M2W_POP3_SERVER_PORT, M2W_POP3_SERVER_USER, M2W_POP3_SERVER_PASSWORD)
	mail_command_processor.add(WeblogCommand.new(M2W_WEBLOG_EXTENSION, M2W_SUBJECT_HEADER, mail_parser, mail_sender))

	mail_command_processor.run

rescue => e
	M2W_LOGGER.error(e)
	exit(1)
end

puts "Content-type: text/plain\n\n"
puts "このプログラムは、cron などのスケジュール管理ソフトから呼び出すのが妥当です。"
