# coding: UTF-8

require 'mailutils/mail_processor'
require 'plugin/command/lib/standard_command'

#=ブログ投稿コマンド
#
# 最初の著者:: トゥイー
# リポジトリ情報:: $Id: post.rb 198 2011-08-11 18:39:50Z toy_dev $
# 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
# ライセンス:: CPL(Common Public Licence)
class Post_CommandPlugin < StandardCommand

	def run_before_parsing
		if @weblog != nil then
			@weblog 
			@post_plugin = @weblog.get_post_plugin
		end
	end

	def header_alias()
		result = {}

		if @post_plugin != nil then
			result = result.merge(@post_plugin.header_alias)
		end

		return result
	end

	def run_after_parsing(header, content)
		@report = {}

		if @post_plugin != nil then
			result = @post_plugin.post(header, content, @mail.attachments, @param)
			@report = @post_plugin.report.clone

			if M2W_REPLY && @mail_sender != nil then
				if result then
send_content = <<"END_CONTENT"
ブログ記事の投稿に成功しました。

投稿したブログ記事を編集したい場合は、本メールをそのまま返信すると編集用のメールが届きます。
END_CONTENT
					@mail_sender.sendmail_as_command("get", @param, {"postid" => @report[:postid]}, send_content, @mail.from_address, [])
				else
send_content = <<"END_CONTENT"
ブログ記事の投稿に失敗しました。
END_CONTENT
					@mail_sender.sendmail_as_command("error", @param, {}, send_content, @mail.from_address, [])
				end
			end

			return result
		end

		return false
	end

end
