# coding: UTF-8

require 'tempfile'
require 'mailutils/mime'
require 'plugin/weblog/lib/weblog_post_common'

module AtomPubWeblogPostCommon
	include WeblogPostCommon

	def post_media(content, attachment_index, media_name, client, username, password, blogid, postid, header, vars, attachments, dateCreated, errors, warnings)
		filename = attachments[attachment_index - 1].filename

		mime = Mime.new

		tempfile = Tempfile.new("content")
		tempfile.binmode
		tempfile.write(content)
		tempfile.close

		M2W_LOGGER.debug("Start  AtomPub.create_media ... index = #{attachment_index}, media_name = #{media_name}")
		create_media_result = client.create_media(@parent.media_collection_uri, tempfile.path, mime.mime(filename))
		M2W_LOGGER.debug("Finish AtomPub.create_media ... result = #{create_media_result}")

		media_url = nil

		if create_media_result != nil then
			M2W_LOGGER.debug("Start  AtomPub.get_media")
			media_entry = client.get_entry(create_media_result)
			M2W_LOGGER.debug("Finish AtomPub.get_media ... result = #{media_entry}")

			if media_entry != nil then
				media_entry.elem.each_element("content") do |element|
					media_url = element.attributes['src']
				end
			end
		end

		M2W_LOGGER.debug("post content media_result ... media_url = #{media_url}")
		return media_url
	end

end
