# coding: UTF-8

require 'plugin/weblog/atom_pub/atom_pub_get'

#=はてなダイアリーのためのブログ記事取得用ウェブログプラグイン
#
# 最初の著者:: トゥイー
# リポジトリ情報:: $Id: hatena_diary_get.rb 495 2012-01-30 04:45:59Z toy_dev $
# 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
# ライセンス:: CPL(Common Public Licence)
class HatenaDiaryGet_WeblogPlugin < AtomPubGet_WeblogPlugin

	def get_attachments(urls)
		return []
	end

	def parse_description(entry)
		entry.elem.each_element("hatena:syntax") do |element|
			return element.text
		end
		raise WeblogPluginError.new(
			"本文取得エラー",
			"本文の取得に失敗しました。"
		)
	end

	def parse_link(entry)
		entry.elem.each_element_with_attribute("rel", "alternate") do |element|
			return element.attributes['href']
		end
		raise WeblogPluginError.new(
			"リンク取得エラー",
			"リンクの取得に失敗しました。"
		)
	end

end
